diff --git a/libglusterfs/src/dict.c b/libglusterfs/src/dict.c
index f0a3d68f036..e1e951e1c7b 100644
--- a/libglusterfs/src/dict.c
+++ b/libglusterfs/src/dict.c
@@ -2760,22 +2760,13 @@ dict_rename_key(dict_t *this, char *key, char *replace_key)
  *        : failure: -errno
  */
 
-int
+unsigned int
 dict_serialized_length_lk(dict_t *this)
 {
-    int ret = -EINVAL;
-    int count = this->count;
-    const int keyhdrlen = DICT_DATA_HDR_KEY_LEN + DICT_DATA_HDR_VAL_LEN;
-
-    if (count < 0) {
-        gf_smsg("dict", GF_LOG_ERROR, EINVAL, LG_MSG_COUNT_LESS_THAN_ZERO,
-                "count=%d", count, NULL);
-        goto out;
-    }
+    unsigned int count = this->count;
+    const unsigned int keyhdrlen = DICT_DATA_HDR_KEY_LEN + DICT_DATA_HDR_VAL_LEN;
 
-    ret = DICT_HDR_LEN + this->totkvlen + (count * keyhdrlen);
-out:
-    return ret;
+    return DICT_HDR_LEN + this->totkvlen + (count * keyhdrlen);
 }
 
 /**
@@ -2795,21 +2786,15 @@ dict_serialize_lk(dict_t *this, char *buf)
 {
     int ret = -1;
     data_pair_t *pair = this->members_list;
-    int32_t count = this->count;
-    int32_t keylen = 0;
-    int32_t netword = 0;
+    uint32_t count = this->count;
+    uint32_t keylen = 0;
+    uint32_t netword = 0;
 
     if (!buf) {
         gf_smsg("dict", GF_LOG_ERROR, EINVAL, LG_MSG_INVALID_ARG, NULL);
         goto out;
     }
 
-    if (count < 0) {
-        gf_smsg("dict", GF_LOG_ERROR, 0, LG_MSG_COUNT_LESS_THAN_ZERO,
-                "count=%d", count, NULL);
-        goto out;
-    }
-
     netword = htobe32(count);
     memcpy(buf, &netword, sizeof(netword));
     buf += DICT_HDR_LEN;
@@ -2876,7 +2861,7 @@ dict_unserialize(char *orig_buf, int32_t size, dict_t **fill)
 {
     char *buf = orig_buf;
     int ret = -1;
-    int32_t count = 0;
+    uint32_t count = 0;
     int i = 0;
 
     data_t *value = NULL;
@@ -2921,12 +2906,6 @@ dict_unserialize(char *orig_buf, int32_t size, dict_t **fill)
     count = be32toh(hostord);
     buf += DICT_HDR_LEN;
 
-    if (count < 0) {
-        gf_smsg("dict", GF_LOG_ERROR, 0, LG_MSG_COUNT_LESS_THAN_ZERO,
-                "count=%d", count, NULL);
-        goto out;
-    }
-
     /* count will be set by the dict_set's below */
     (*fill)->count = 0;
 
@@ -3028,10 +3007,6 @@ dict_allocate_and_serialize(dict_t *this, char **buf, u_int *length)
     LOCK(&this->lock);
     {
         len = dict_serialized_length_lk(this);
-        if (len < 0) {
-            ret = len;
-            goto unlock;
-        }
 
         *buf = GF_MALLOC(len, gf_common_mt_char);
         if (*buf == NULL) {
@@ -3073,7 +3048,7 @@ dict_serialize_value_with_delim_lk(dict_t *this, char *buf, int32_t *serz_len,
                                    char delimiter)
 {
     int ret = -1;
-    int32_t count = this->count;
+    uint32_t count = this->count;
     int32_t vallen = 0;
     int32_t total_len = 0;
     data_pair_t *pair = this->members_list;
@@ -3083,12 +3058,6 @@ dict_serialize_value_with_delim_lk(dict_t *this, char *buf, int32_t *serz_len,
         goto out;
     }
 
-    if (count < 0) {
-        gf_smsg("dict", GF_LOG_ERROR, EINVAL, LG_MSG_INVALID_ARG, "count=%d",
-                count, NULL);
-        goto out;
-    }
-
     while (count) {
         if (!pair) {
             gf_smsg("dict", GF_LOG_ERROR, 0, LG_MSG_PAIRS_LESS_THAN_COUNT,
@@ -3303,7 +3272,7 @@ dict_unserialize_specific_keys(char *orig_buf, int32_t size, dict_t **fill,
 {
     char *buf = orig_buf;
     int ret = -1;
-    int32_t count = 0;
+    uint32_t count = 0;
     int i = 0;
     int j = 0;
 
@@ -3350,12 +3319,6 @@ dict_unserialize_specific_keys(char *orig_buf, int32_t size, dict_t **fill,
     count = be32toh(hostord);
     buf += DICT_HDR_LEN;
 
-    if (count < 0) {
-        gf_smsg("dict", GF_LOG_ERROR, 0, LG_MSG_COUNT_LESS_THAN_ZERO,
-                "count=%d", count, NULL);
-        goto out;
-    }
-
     /* Compute specific key length and save in array */
     for (i = 0; i < totkeycount; i++) {
         keylenarr[i] = strlen(suffix_key_arr[i]);
diff --git a/libglusterfs/src/glusterfs/dict.h b/libglusterfs/src/glusterfs/dict.h
index cd96eaf8ff4..a040d47ab10 100644
--- a/libglusterfs/src/glusterfs/dict.h
+++ b/libglusterfs/src/glusterfs/dict.h
@@ -102,7 +102,7 @@ struct _data_pair {
 
 struct _dict {
     uint64_t max_count;
-    int32_t count;
+    uint32_t count;
     /* Variable to store total keylen + value->len */
     uint32_t totkvlen;
     gf_atomic_t refcount;
@@ -459,7 +459,7 @@ are_dicts_equal(dict_t *one, dict_t *two,
 int
 dict_has_key_from_array(dict_t *dict, char **strings, gf_boolean_t *result);
 
-int
+unsigned int
 dict_serialized_length_lk(dict_t *this);
 
 int32_t
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index ff6b3aff4e7..4ddeb227e0e 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -3227,13 +3227,13 @@ glusterd_add_bulk_volumes_create_thread(void *data)
 }
 
 static int
-glusterd_dict_searialize(dict_t *dict_arr[], int count, int totcount, char *buf)
+glusterd_dict_searialize(dict_t *dict_arr[], unsigned int count, unsigned int totcount, char *buf)
 {
     int i = 0;
-    int32_t keylen = 0;
-    int64_t netword = 0;
+    uint32_t keylen = 0;
+    uint64_t netword = 0;
     data_pair_t *pair = NULL;
-    int dict_count = 0;
+    unsigned int dict_count = 0;
     int ret = 0;
 
     netword = htobe32(totcount);
@@ -3299,12 +3299,12 @@ glusterd_dict_searialize(dict_t *dict_arr[], int count, int totcount, char *buf)
 }
 
 static int
-glusterd_dict_arr_serialize(dict_t *dict_arr[], int count, char **buf,
+glusterd_dict_arr_serialize(dict_t *dict_arr[], unsigned int count, char **buf,
                             u_int *length)
 {
     ssize_t len = 0;
     int i = 0;
-    int totcount = 0;
+    unsigned int totcount = 0;
     int ret = 0;
 
     for (i = 0; i < count; i++) {
@@ -3350,7 +3350,7 @@ glusterd_add_volumes_to_export_dict(dict_t *peer_data, char **buf,
     int32_t count = 0;
     glusterd_dict_ctx_t ctx = {0};
     xlator_t *this = THIS;
-    int totthread = 0;
+    unsigned int totthread = 0;
     int volcnt = 0;
     int start = 1;
     int endindex = 0;
